/*
========================================

========================================
*/

fn SC2_WriteHeader bstream H=
(
	format "Writing header...\n"
	WriteByte bstream 77
	WriteByte bstream 79
	WriteByte bstream 68
	WriteByte bstream 76
	--- version number
	WriteLong bstream 7 #unsigned
	WriteLong bstream H.boneoffset #unsigned
	WriteLong bstream H.wbonecount #unsigned
	
	WriteLong bstream H.vertoffset #unsigned
	WriteLong bstream H.xtraoffset #unsigned		--- extra vert offset ---
	WriteLong bstream H.vertcount #unsigned
	WriteLong bstream H.indexoffset #unsigned
	
	WriteLong bstream H.indexcount #unsigned
	WriteLong bstream H.infooffset #unsigned
	WriteLong bstream H.infocount #unsigned
	WriteLong bstream H.totalbones #unsigned
	
	--MATS
	WriteLong bstream H.materialoffset #unsigned
	WriteLong bstream H.materialnum #unsigned
	
	--pad
	for i = 1 to 4 do WriteByte bstream 197
	WriteByte bstream 78
	WriteByte bstream 65
	WriteByte bstream 77
	WriteByte bstream 69
)
fn SC2_WriteBonelist bstream bonelist=
(
	format "Writing bonelist...\n"
	for i = 1 to bonelist.bones.count do Writestring bstream bonelist.bones[i]
	for i = 1 to bonelist.padding do WriteByte bstream 187
	WriteByte bstream 83 -- SKEL
	WriteByte bstream 75
	WriteByte bstream 69
	WriteByte bstream 76
)
fn SC2_WriteBones bstream bones padding=
(
	format "Writing bone data...\n"
	for i = 1 to bones.count do SC2_WriteBone bstream bones[i]
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 86 -- VTXL
	WriteByte bstream 84
	WriteByte bstream 88
	WriteByte bstream 76
)
fn SC2_WriteBone bstream bone=
(
	WriteFloat bstream bone.RestPoseInverse1[1] 
	WriteFloat bstream bone.RestPoseInverse2[1] 
	WriteFloat bstream bone.RestPoseInverse3[1] 
	WriteFloat bstream 0.0 
	
	WriteFloat bstream bone.RestPoseInverse1[2] 
	WriteFloat bstream bone.RestPoseInverse2[2] 
	WriteFloat bstream bone.RestPoseInverse3[2] 
	WriteFloat bstream 0.0
	
	WriteFloat bstream bone.RestPoseInverse1[3] 
	WriteFloat bstream bone.RestPoseInverse2[3] 
	WriteFloat bstream bone.RestPoseInverse3[3] 
	WriteFloat bstream 0.0 
	
	WriteFloat bstream bone.RestPoseInverse4[1] 
	WriteFloat bstream bone.RestPoseInverse4[2] 
	WriteFloat bstream bone.RestPoseInverse4[3] 
	WriteFloat bstream 1.0 

	WriteFloat bstream bone.Position[1] 
	WriteFloat bstream bone.Position[2] 
	WriteFloat bstream bone.Position[3] 
	
	WriteFloat bstream bone.Rotation.w 
	WriteFloat bstream bone.Rotation.x 
	WriteFloat bstream bone.Rotation.y 
	WriteFloat bstream bone.Rotation.z 

	WriteLong bstream bone.nameoffset #unsigned
	WriteLong bstream bone.parentboneindex #unsigned
	
	WriteLong bstream 0 #unsigned
	WriteLong bstream 0 #unsigned
)

fn SC2_WriteVerts bstream verts padding=
(
	format "Writing vert data...\n"
	for i = 1 to verts.count do SC2_WriteVert bstream verts[i]
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 84 -- TRIS
	WriteByte bstream 82
	WriteByte bstream 73
	WriteByte bstream 83
)
fn SC2_WriteVert bstream vert=
(
	--position
		WriteFloat bstream vert.Position[1]
		WriteFloat bstream vert.Position[2]
		WriteFloat bstream vert.Position[3]
		--normal
		WriteFloat bstream vert.Normal[1]
		WriteFloat bstream vert.Normal[2]
		WriteFloat bstream vert.Normal[3]
		--tangent
		WriteFloat bstream vert.Tangent[1]
		WriteFloat bstream vert.Tangent[2]
		WriteFloat bstream vert.Tangent[3]
		--binormal
		WriteFloat bstream vert.Bitangent[1]
		WriteFloat bstream vert.Bitangent[2]
		WriteFloat bstream vert.Bitangent[3]
		--uv1
		WriteFloat bstream vert.uv1[1]
		WriteFloat bstream ( 1 - vert.uv1[2] )
		--uv2
		WriteFloat bstream vert.uv2[1]
		WriteFloat bstream ( 1 - vert.uv2[2] )
		--boneindex
		WriteByte bstream vert.boneindex[1] #unsigned
		WriteByte bstream vert.boneindex[2] #unsigned
		WriteByte bstream vert.boneindex[3] #unsigned
		WriteByte bstream vert.boneindex[4] #unsigned
)
fn SC2_WriteTris bstream tris padding=
(
	format "Writing tris data...\n"
	for i = 1 to tris.count do
	(
		WriteShort bstream ( tris[i][1] - 0 ) #unsigned 
		WriteShort bstream ( tris[i][2] - 0 ) #unsigned
		WriteShort bstream ( tris[i][3] - 0 ) #unsigned
	)
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 88 -- XTRA
	WriteByte bstream 84
	WriteByte bstream 82
	WriteByte bstream 65
)
fn SC2_WriteXtra bstream verts padding=
(
	format "Writing Xtra data...\n"
	for i = 1 to verts.count do
	(
		vw = verts[i].boneweights
		WriteByte bstream vw[1] #unsigned 
		WriteByte bstream vw[2] #unsigned 
		WriteByte bstream vw[3] #unsigned 
		WriteByte bstream vw[4] #unsigned 
	)
	for i = 1 to padding do WriteByte bstream 187
	WriteByte bstream 73
	WriteByte bstream 78
	WriteByte bstream 70
	WriteByte bstream 79
)